#include <AFMotor.h>
#include <IBusBM.h>
IBusBM ibus;

AF_DCMotor motor1(1, MOTOR12_64KHZ);
AF_DCMotor motor2(2, MOTOR12_64KHZ);
AF_DCMotor motor3(3, MOTOR12_64KHZ);
AF_DCMotor motor4(4, MOTOR12_64KHZ);

void setup() {
  Serial.begin(115200);
  ibus.begin(Serial);
  motor1.setSpeed(120);
  motor2.setSpeed(120);
  motor3.setSpeed(120);
  motor4.setSpeed(120);
}

void loop() {

  double ch1Value = readChannel(0, -100, 100, 0);
  double ch2Value = readChannel(1, -100, 100, 0);
  double ch3Value = readChannel(2, -100, 100, 0);
  double ch4Value = readChannel(3, -100, 100, 0);

  if ((ch1Value == 0) && (ch2Value == 0))
  {
    motor3.run(RELEASE);//Front left
    motor1.run(RELEASE);//Rear left
    motor4.run(RELEASE);//Front right
    motor2.run(RELEASE);//Rear right
  }
  if ((ch1Value < 30) && (ch2Value < -50))
  {
    motor3.run(FORWARD);//Forwards
    motor1.run(FORWARD);
    motor4.run(FORWARD);
    motor2.run(FORWARD);
  }
  else if ((ch1Value < 30) && (ch2Value > 50))
  {
    motor3.run(BACKWARD);//Backwards
    motor1.run(BACKWARD);
    motor4.run(BACKWARD);
    motor2.run(BACKWARD);
  }
  else if ((ch1Value < -50) && (ch2Value < 30))
  {
    motor3.run(BACKWARD);//Turn Left
    motor1.run(FORWARD);
    motor4.run(FORWARD);
    motor2.run(BACKWARD);
  }
  else if ((ch1Value > 50) && (ch2Value < 30))
  {
    motor3.run(FORWARD);//Turn Right
    motor1.run(BACKWARD);
    motor4.run(BACKWARD);
    motor2.run(FORWARD);
  }
  else if ((ch4Value < -50) && (ch2Value < 30))
  {
    motor3.run(BACKWARD);//Slew left
    motor1.run(BACKWARD);
    motor4.run(FORWARD);
    motor2.run(FORWARD);
  }
  else if ((ch4Value > 50) && (ch2Value < 30))
  {
    motor3.run(FORWARD);//Slew right
    motor1.run(FORWARD);
    motor4.run(BACKWARD);
    motor2.run(BACKWARD);
  }
  else if ((ch3Value < -50) && (ch4Value < 30))
  {
    motor3.run(FORWARD);//Diagonal
    motor1.run(FORWARD);
    motor4.run(RELEASE);
    motor2.run(RELEASE);
  }

  else if ((ch3Value > 50) && (ch4Value < 30))
  {
    motor3.run(RELEASE);//Diagonal
    motor1.run(RELEASE);
    motor4.run(BACKWARD);
    motor2.run(BACKWARD);
  }
  else if ((ch4Value > 50) && (ch3Value < 30))
  {
    motor3.run(RELEASE);//DIAGONAL RIGHT
    motor1.run(BACKWARD);
    motor4.run(BACKWARD);
    motor2.run(RELEASE);
  }
 else if ((ch4Value > 50) && (ch3Value < 30))
  {
    motor3.run(RELEASE);//DIAGONAL RIGHT
    motor1.run(FORWARD);
    motor4.run(FORWARD);
    motor2.run(RELEASE);
  }
else
  {
    motor3.run(RELEASE);
    motor1.run(RELEASE);
    motor4.run(RELEASE);
    motor2.run(RELEASE);
  }
  delay(200);
}

int readChannel(byte channelInput, int minLimit, int maxLimit, int defaultValue) {
  uint16_t ch = ibus.readChannel(channelInput);
  if (ch < 100) return defaultValue;
  return map(ch, 1000, 2000, minLimit, maxLimit);
}
